<script setup>
import { ref, reactive } from "vue";
import UpdateModal from "./UpdateModal.vue";

// initialize reactive variables
const newTask = ref("");
const todos = reactive({ list: [], taskToBeUpdated: null });

/**
 * addTodo
 * Adds a new task in todolist
 */
const addTodo = () => {
  if (newTask.value?.length !== 0) {
    todos.list.push({
      _id: Date.now(),
      value: newTask.value,
      isCompleted: false,
    });
    newTask.value = "";
  }
};

/**
 * updateTodo
 * @param {*} todo
 * @param {*} newValue
 * Handler for updating the task value
 */
const updateTodo = (todo, newValue) => {
  if (newValue?.length !== 0) {
    todos.list = todos.list.map((t) => {
      if (todo._id === t._id) {
        return { ...todo, value: newValue };
      }
      return t;
    });
    todos.taskToBeUpdated = null;
  }
};

/**
 * deleteTodo
 * @param {*} _id
 * Delete a single task by its _id
 */
const deleteTodo = (_id) => {
  todos.list = todos.list.filter((t) => t._id !== _id);
};

const deleteAllTodo = () => {
  todos.list = [];
};

/**
 *
 * @param {*} todo
 * Change the status of task if it is Pending or Completed
 */
const changeStatus = (todo) => {
  todos.list = todos.list.map((t) => {
    const newStatus = !t.isCompleted;
    if (todo._id === t._id) {
      return { ...todo, isCompleted: newStatus };
    }
    return t;
  });
};

// Show update modal by populating taskToBeUpdated
const showUpdateModal = (todo) => {
  todos.taskToBeUpdated = todo;
};
</script>

<template>
  <main class="flex flex-col justify-center items-center">
    <!-- Shows update modal if taskToBeUpdated is not null -->
    <div class="modal-container" v-if="!!todos.taskToBeUpdated">
      <UpdateModal
        :task="todos.taskToBeUpdated"
        @close="todos.taskToBeUpdated = null"
        @onUpdate="updateTodo"
      />
      <div class="overlay"></div>
    </div>

    <!-- Input div for adding new task -->
    <div class="todo-input flex justify-center">
      <input
        @keyup.enter="addTodo"
        type="text"
        placeholder="New Task"
        v-model="newTask"
      />
      <button @click="addTodo" class="btn-primary">+ Add Task</button>
      <button @click="deleteAllTodo" class="btn-danger">Delete All</button>
    </div>

    <span class="note">You can double click the task to change its status</span>

    <!-- Task Cards container -->
    <TransitionGroup name="list" tag="div" class="card-container flex flex-col">
      <div
        v-for="task in todos.list"
        :key="task._id"
        class="card flex justify-between"
        @dblclick="changeStatus(task)"
        :class="{ completed: task.isCompleted }"
      >
        <div>
          <h4>{{ task.value }}</h4>

          <!-- Conditional rendering task status if completed or pending -->
          <div>Status: {{ task.isCompleted ? "Completed" : "Pending" }}</div>
        </div>
        <div class="btn-container flex items-center">
          <!-- button for updating the task -->
          <button
            @click="showUpdateModal(task)"
            class="edit flex items-center justify-center"
          >
            <i class="fa fa-pencil" aria-hidden="true"></i>
          </button>

          <!-- button for deleting task -->
          <div
            @click="deleteTodo(task._id)"
            class="delete flex items-center justify-center"
          >
            X
          </div>
        </div>
      </div>
    </TransitionGroup>
  </main>
</template>

<style scoped>
main {
  margin-top: 50px;
}
.todo-input {
  gap: 10px;
  flex-wrap: wrap;
  position: sticky;
  top: 0;
  background: #f8f8f8;
  padding: 10px;
}
.note {
  margin-top: 10px;
  color: grey;
}
input {
  padding: 10px;
  max-width: 600px;
  width: 100%;
  font-size: 24px;
}
.card-container {
  margin-top: 30px;
  max-width: 500px;
  width: 100%;
  gap: 1rem;
}
.card {
  padding: 1rem;
  min-height: 80px;
  box-shadow: 0 0 5px rgba(0, 0, 0, 0.4);
  border-radius: 15px;
  max-width: 500px;
  width: 100%;
  cursor: pointer;
  user-select: none;
}
.completed {
  background: var(--c-pri);
  color: #ffffff;
}
.btn-container {
  gap: 10px;
}
</style>
